
package surfingsafari;


public class RandomSurfer {
    private double [][] probabilities;
    private int n;
    private int [] frequencies;
    private double [] ranks;
    
    public RandomSurfer( TransitionMatrix matrix, int numberOfTransitions ) {
        probabilities = matrix.getProbabilities();
        n = matrix.getN();
        
        int page = 0;
        frequencies = new int[ n ];
        for( int t = 0; t < numberOfTransitions; t++ ) {
            double r = Math.random();
            double sum = 0.0;
            for( int j = 0; j < n; j++ ) {
                sum += probabilities[page][j];
                
                if( r < sum ) {
                    page = j;
                    break;
                } // if
            } // for
            frequencies[page]++;
        } // for
        
        ranks = new double[n];
        for( int i = 0; i < n; i++ ) {
            ranks[i] = (double) frequencies[i] / numberOfTransitions;
        } // for
    } // RandomSurfer( TransitionMatrix, int )

    
    public int[] getFrequencies() {
        return frequencies;
    } // getFrequencies()

    public double[] getRanks() {
        return ranks;
    } // getRanks()
    
} // RandomSurfer
