package surfingsafari;

import edu.princeton.cs.In;

public class TransitionMatrix {

    private int n;
    private int[][] counts;
    private int[] outDegree;
    private double[][] probabilities;

    public TransitionMatrix(String fileName) {
        In inputStream = new In(fileName);
        n = inputStream.readInt();
        counts = new int[n][n];
        outDegree = new int[n];
        probabilities = new double[n][n];

        while (!inputStream.isEmpty()) {
            int i = inputStream.readInt();
            int j = inputStream.readInt();

            outDegree[i]++;
            counts[i][j]++;
        } // while

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                probabilities[i][j] = 0.9 * counts[i][j] / outDegree[i] + 0.1 / n;
            } // for
        } // for
    } // TransitionMatrix

    public int getN() {
        return n;
    } // getN()

    public int[][] getCounts() {
        return counts;
    } // getCounts()

    public int[] getOutDegree() {
        return outDegree;
    } // getOutDegree()

    public double[][] getProbabilities() {
        return probabilities;
    } // getProbabilities()
    
    public double getProbability( int fromPage, int toPage ) {
        return probabilities[fromPage][toPage];
    } // getProbability( int, int )
    
} // TransitionMatrix
